// ==> versuch1/normalerprozess.c
#include <stdio.h>
#include <stdlib.h>
#include <asm/io.h>
#include <signal.h>

#define BASEPORT 0x378

static int end;

static void endme(int dummy) { end=1; }

int main(int argc, char **argv) {

	// STRG-C abfangen
	signal(SIGINT, endme);

	// ParPort IO-Rechte holen (3 Bytes des IO-Bereichs, 1=Zugriff erlauben)
	if (ioperm(BASEPORT, 3, 1)) {  perror("ioperm open");  exit(1);  }

	// ParPort in Ausgabemodus versetzen
	outb(0, BASEPORT + 2);

	// Datenpins toggeln
	while (!end) {

		// krzer warten geht leider nicht bzw. macht er einfach nicht ...
		usleep(1000);
		outb(0, BASEPORT);

		usleep(1000);
		outb(255, BASEPORT);
	}

	// ParPort IO-Rechte freigeben (3 Bytes des IO-Bereichs, 0=Zugriff sperren)
	if (ioperm(BASEPORT, 3, 0)) { perror("ioperm close"); }

	exit(0);

}
