#include <linux/module.h>

#include <rtai.h>
#include <rtai_sched.h>

#define TICK_PERIOD 50000
#define TASK_PRIORITY 1
#define STACK_SIZE 10000
#define BASEPORT 0x378

static RT_TASK  rt_task;
static RTIME    tick_period;


static void toggle( int t ) {
	while (1) {
		outb(0, BASEPORT);
		rt_task_wait_period();
		outb(255, BASEPORT);
		rt_task_wait_period();
	}
}


int xinit_module(void) {
	outb(0, BASEPORT + 2); //set port to output mode
	//RTIME tick_period;
	rt_set_periodic_mode();
	rt_task_init(&rt_task, toggle, 1, STACK_SIZE, TASK_PRIORITY, 1, 0);
	tick_period = start_rt_timer(nano2count(TICK_PERIOD));
	rt_task_make_periodic(&rt_task, rt_get_time() + tick_period, tick_period);
	return 0;
}


void xcleanup_module(void) {
	stop_rt_timer();
	rt_task_delete(&rt_task);
	return;
}


module_init(xinit_module);
module_exit(xcleanup_module);

MODULE_LICENSE("GPL");

